/* -----------------------------------------------------------------------
 *
 * Project:     ttsnmp
 *
 * Filename:    ttWait.c
 *
 * Date:        March 1995
 *
 * Purpose:     Wait command implementation
 *
 * Author:      Bram van der Waaij      
 *
 *           _o______=====____H_=======_H______=====__        __=====_____H_===
 *          |_______|[[[[[     \#######/       [[[[[ o|      |o ]]]]]      \###
 *     ______| [][] |____    B.D. van der Waaij      ||      || 
 *    |o ____|      |__| \___________________________||      ||________________
 *  |_| /DCC |_7189_|   \_|  |  |  |  |  |  |  |  |  ||_|  |_||  |  |  |  |  | 
 * @|_|=|====|======|=o=|=============================|_|@@|_|=|====|======|===
 *  |_| [(o)==(o)]  |__________________|   [(o)==(o)] |_|\/|_| [(o)==(o)]  |___
 * ============================================================================
 ***[]****[]****[]****[]****[]****[]****[]****[]****[]****[]****[]****[]****[]*/

#include <tcl.h>
#include <tk.h>
#include <UT-SNMP.h>
#include <ttCallList.h>
#include <ttWait.h>

/*
 * -----------------------------------------------------------------------
 *
 * TCL Command:	<agent> wait
 *
 * TCL Args:	callid
 *
 * TCL example:	<agent> wait 1
 *
 * Return:	CallID
 *
 * Purpose:	wait for a request
 *
 * Remarks:	
 *
 * -----------------------------------------------------------------------
 */
int SnmpWaitCommand( ClientData clientdata, 
                     Tcl_Interp *interp, int argc, char *argv[] ) 
{
  int        CallID;
  char       result[255];
  TCallInfo  callinfo;

  if (argc < 3) {
    Tcl_SetResult( interp, "missing call id", TCL_VOLATILE );
    return TCL_ERROR;
  }

  CallID = atoi(argv[2]);          /* convert callid */
    
    /* wait until the callid is removed from the call list */
  while (GetCall( CallID, &callinfo ) == OK)
    Tk_DoOneEvent( TK_ALL_EVENTS );

  sprintf( result, "%i", CallID );
  Tcl_SetResult( interp, result, TCL_VOLATILE );
  return TCL_OK;
}
